"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.deployCli = exports.deployLambda = void 0;
var lambda_1 = __importDefault(require("aws-sdk/clients/lambda"));
var infra_aws_1 = require("@goldstack/infra-aws");
var templateLambdaExpressConfig_1 = require("./templateLambdaExpressConfig");
var infra_1 = require("@goldstack/infra");
var archiver_1 = __importDefault(require("archiver"));
var fs_1 = __importDefault(require("fs"));
var utils_aws_cli_1 = require("@goldstack/utils-aws-cli");
var createLambdaClient = function (deployment) { return __awaiter(void 0, void 0, void 0, function () {
    var awsUser;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, infra_aws_1.getAWSUser(deployment.awsUser)];
            case 1:
                awsUser = _a.sent();
                return [2 /*return*/, new lambda_1.default({
                        apiVersion: '2015-03-31',
                        credentials: awsUser,
                    })];
        }
    });
}); };
exports.deployLambda = function (params) { return __awaiter(void 0, void 0, void 0, function () {
    var targetArchive, lambdaDistDir, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                targetArchive = 'lambda.zip';
                lambdaDistDir = './distLambda';
                return [4 /*yield*/, new Promise(function (resolve, reject) {
                        var output = fs_1.default.createWriteStream(targetArchive);
                        var archive = archiver_1.default('zip', {
                            zlib: { level: 9 },
                        });
                        archive.on('warning', function (err) {
                            console.warn(err.message);
                        });
                        output.on('finish', function () {
                            resolve();
                        });
                        output.on('error', reject);
                        archive.pipe(output);
                        archive.directory(lambdaDistDir, false);
                        archive.finalize();
                    })];
            case 1:
                _c.sent();
                _a = utils_aws_cli_1.awsCli;
                _b = {};
                return [4 /*yield*/, infra_aws_1.getAWSUser(params.deployment.awsUser)];
            case 2:
                _a.apply(void 0, [(_b.credentials = _c.sent(),
                        _b.region = params.deployment.awsRegion,
                        _b.command = "lambda update-function-code --function-name " + infra_1.readTerraformStateVariable(params.deploymentState, 'lambda_function_name') + " --zip-file fileb://" + targetArchive,
                        _b)]);
                return [2 /*return*/];
        }
    });
}); };
exports.deployCli = function (config, args) { return __awaiter(void 0, void 0, void 0, function () {
    var deploymentName, deployment, deploymentState;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                deploymentName = args[0];
                deployment = templateLambdaExpressConfig_1.getDeployment(config.infrastructure, [deploymentName]);
                deploymentState = infra_1.readDeploymentState('./', deploymentName);
                return [4 /*yield*/, exports.deployLambda({
                        deployment: deployment,
                        deploymentState: deploymentState,
                    })];
            case 1:
                _a.sent();
                return [2 /*return*/];
        }
    });
}); };
//# sourceMappingURL=templateLambdaExpressDeploy.js.map